
freeslot("SPR_DAVY", "sfx_dtho", "sfx_geme", "sfx_dwal", "sfx_dwol", "sfx_drun")

sfxinfo[sfx_geme].caption = "DAAH~"
sfxinfo[sfx_dtho].caption = "Yiieea"
sfxinfo[sfx_dwal].caption = "Fwap"
sfxinfo[sfx_dwol].caption = "Fwop"

local function jiggle(mo, stage, momsource)
	local adjustedMom = (momsource/FRACUNIT)/2
	local distortion = sin( FixedAngle(stage*FRACUNIT)*adjustedMom )/9
	local destscaleX = FRACUNIT + distortion
	local destscaleY = FRACUNIT - distortion
	if not (mo.spritexscale == destscaleX) then mo.spritexscale = $ - (abs($) - destscaleX)/5 end
	if not (mo.spriteyscale == destscaleY) then mo.spriteyscale = $ - (abs($) - destscaleY)/5 end
end

addHook("MobjThinker", function(cork)
	S_StopSoundByID(cork, sfx_corkp)
	if not cork.davy and cork.target.valid and cork.target.player and cork.target.skin == "davyjones"
		cork.sprite = SPR_DAVY
		S_StartSound(cork, sfx_dtho)
		cork.davy = true
	end
end, MT_CORK)

addHook("PlayerThink", function(p)
	if not p.valid return end
	if not p.mo or not p.mo.valid return end
	if p.mo.skin ~= "davyjones" return end

	if not p.davy then p.davy = {} end
	p.davy.alternator = $ or 1
	local squosh = (p.davy.alternator == 1 and sfx_dwal or sfx_dwol)

	p.davy.jiggle = $ or 1
	if p.panim == PA_WALK or p.panim == PA_RUN
		if p.speed < 28*FRACUNIT
			S_StopSoundByID(cork, sfx_drun)
			if not (leveltime%15)
				S_StartSound(cork, squosh)
				p.davy.alternator = -$
			end
		else
			S_StopSoundByID(cork, squosh)
			if not (leveltime%8) then S_StartSound(cork, sfx_drun) end
		end
		p.davy.jiggle = $ + 1
		jiggle(p.mo, p.davy.jiggle, p.speed)
	else
		p.davy.jiggle = 0
	end
end)